program ZIB1177;

(*********************************
 *  Programm zur Karte ZIB 1177  *
 *********************************)
USES Graph,Crt;
CONST   adresse   : integer = $101; {Portadresse Adressregister}
        Basis     : array [0..7] of integer = (0,8,16,24,32,40,48,56);
        zaehler   : integer = $100; {Portadresse ZhlerDatenBus}
        VorCh     : array [0..7] of array [1..7] of string =
                    ((' ',' ',' ',' ',' ',' ',' '),(' ',' ',' ',' ',' ',' ',' '),
                     (' ',' ',' ',' ',' ',' ',' '),(' ',' ',' ',' ',' ',' ',' '),
                     (' ',' ',' ',' ',' ',' ',' '),(' ',' ',' ',' ',' ',' ',' '),
                     (' ',' ',' ',' ',' ',' ',' '),(' ',' ',' ',' ',' ',' ',' '));
        Ende      : boolean = FALSE;
VAR     i,n       : integer;
        Wert      : array [0..7] of integer;
        remkey    : integer;

procedure Bildschirm;
var  GraphDriver,GraphMode : integer;
begin
     GraphDriver:=Detect;
     InitGraph(GraphDriver,GraphMode,'\TP5');
     Rectangle(0,0,GetMaxX,GetMaxY-40);
     MoveTo(0,25); LineTo(GetMaxX,25);
     SetTextStyle(SansSerifFont,HorizDir,2);
     SetTextJustify(CenterText,CenterText);
     OutTextXY(GetMaxX div 2,10,'Zhlerprfprogramm      ZIB 1177');
     MoveTo(0,GetMaxY-53); LineTo(GetMaxX,GetMaxY-53);
     SetTextStyle(DefaultFont,HorizDir,1);
     OutTextXY(GetMaxX div 2,GetMaxY-45,'R : Software - Reset                         ESC : Ende des Programms');
     for i:=1 to 4 do begin
         Rectangle(5,(i-1)*(GetMaxY-80) div 4+28,GetMaxX div 2-3,i*(GetMaxY-80) div 4+23);
         Rectangle(GetMaxX div 2+2,(i-1)*(GetMaxY-80) div 4+28,GetMaxX-5,i*(GetMaxY-80) div 4+23);
     end;
end;


procedure Initialisieren;
begin
     for i:=0 to 7 do begin
         for n:=5 downto 1 do begin
             Port[adresse]:=Basis[i]+n;
             Port[zaehler]:=0;
         end;
     end;
end;

procedure Auslesen;
var  byte  : array [1..4] of integer;
begin
     for i:=0 to 7 do begin
         Port[adresse]:=Basis[i];
         Port[zaehler]:=0;
         for n:=1 to 4 do begin
             Port[adresse]:=Basis[i]+n;
             Byte[n]:=Port[zaehler];
         end;
         Wert[i]:=Byte[1]+256*Byte[2]+256*256*Byte[3]+256*256*256*Byte[4];
     end;
end;

procedure Ausgabe;
var  WertStr  : string;
     ch       : array [0..7] of array [1..7] of string;
begin
     for i:=0 to 7 do begin
         str(Wert[i],WertStr);
         while Length(WertStr)<7 do
               WertStr:=' '+WertStr;
         for n:=1 to 7 do
             ch[i] [n]:=copy(WertStr,n,1);
     end;
     SetTextStyle(SansSerifFont,HorizDir,7);
     for n:=1 to 7 do begin
         for i:=0 to 3 do
         if ch[i] [n]<>VorCh[i] [n] then begin
            SetViewPort((n-1)*GetMaxX div 14+4,i*(GetMaxY-80) div 4+29,
                       n*GetMaxX div 14 -4,(i+1)*(GetMaxY-80) div 4+22,true);
            ClearViewPort;
            OutTextXY(20,25,ch[i] [n]);
            VorCh[i] [n]:=ch[i] [n];
         end;
         for i:=4 to 7 do
         if ch[i] [n]<>VorCh[i] [n] then begin
            SetViewPort((n-1)*GetMaxX div 14+4+(GetMaxX div 2),(i-4)*(GetMaxY-80) div 4+29,
                       n*GetMaxX div 14-6+(GetMaxX div 2),(i-3)*(GetMaxY-80) div 4+22,true);
            ClearViewPort;
            OutTextXY(22,25,ch[i] [n]);
            VorCh[i] [n]:=ch[i] [n];
         end;
     end;
end;

BEGIN
     Bildschirm;
     Initialisieren;
     repeat
           remkey:=0;
           Auslesen;
           Ausgabe;
           if keypressed then remkey:=ord(readkey);
           case remkey of
                27 : Ende:=TRUE;
                82 : Initialisieren;
               114 : Initialisieren;
           end;
     until Ende;
     CloseGraph;
     ClrScr;

END.